searchNodes=[{"ref":"Polyjuice.Util.html","title":"Polyjuice.Util","type":"module","doc":""},{"ref":"Polyjuice.Util.html#escape_localpart/2","title":"Polyjuice.Util.escape_localpart/2","type":"function","doc":"Escape a user ID localpart so that it only uses the allowable character set. The method used is defined in https://matrix.org/docs/spec/appendices#mapping-from-other-character-sets By default, it will escape upper-case letters. If you want upper-case letters to simply be lower-cased, use the fold_case: true option. Examples: iex&gt; Polyjuice.Util.escapelocalpart(&quot;abc\\x01 !\\&quot;,-./09:;&lt;=&gt;?@AZ[\\]^az{|}~á&quot;) &quot;abc=01=20=21=22=2c-./09=3a=3b=3c=3d=3e=3f=40_a_z=5b=5c=5d=5e__=60az=7b=7c=7d=7e=c3=a1&quot; iex&gt; Polyjuice.Util.escape_localpart(&quot;abc\\x01 !\\&quot;,-./09:;&lt;=&gt;?@AZ[\\\\]^_az{|}~á&quot;, foldcase: true) &quot;abc=01=20=21=22=2c-./09=3a=3b=3c=3d=3e=3f=40az=5b=5c=5d=5e=60az=7b=7c=7d=7e=c3=a1&quot;"},{"ref":"Polyjuice.Util.Ed25519.SigningKey.html","title":"Polyjuice.Util.Ed25519.SigningKey","type":"module","doc":""},{"ref":"Polyjuice.Util.Ed25519.SigningKey.html#from_base64/2","title":"Polyjuice.Util.Ed25519.SigningKey.from_base64/2","type":"function","doc":"Create a signing key from the base64 representation."},{"ref":"Polyjuice.Util.Ed25519.SigningKey.html#t:t/0","title":"Polyjuice.Util.Ed25519.SigningKey.t/0","type":"opaque","doc":""},{"ref":"Polyjuice.Util.Ed25519.VerifyKey.html","title":"Polyjuice.Util.Ed25519.VerifyKey","type":"module","doc":""},{"ref":"Polyjuice.Util.Ed25519.VerifyKey.html#from_base64/2","title":"Polyjuice.Util.Ed25519.VerifyKey.from_base64/2","type":"function","doc":"Create a verify key from the base64 representation."},{"ref":"Polyjuice.Util.Ed25519.VerifyKey.html#t:t/0","title":"Polyjuice.Util.Ed25519.VerifyKey.t/0","type":"opaque","doc":""},{"ref":"Polyjuice.Util.Event.html","title":"Polyjuice.Util.Event","type":"module","doc":"Event-related functions."},{"ref":"Polyjuice.Util.Event.html#redact/2","title":"Polyjuice.Util.Event.redact/2","type":"function","doc":"Calculate the redacted version of an event for the given room version. Examples: iex&gt; Polyjuice.Util.Event.redact( ...&gt; &quot;1&quot;, ...&gt; %{ ...&gt; &quot;content&quot; =&gt; %{ ...&gt; &quot;body&quot; =&gt; &quot;Here is the message content&quot; ...&gt; }, ...&gt; &quot;event_id&quot; =&gt; &quot;$0:domain&quot;, ...&gt; &quot;origin&quot; =&gt; &quot;domain&quot;, ...&gt; &quot;origin_server_ts&quot; =&gt; 1000000, ...&gt; &quot;type&quot; =&gt; &quot;m.room.message&quot;, ...&gt; &quot;room_id&quot; =&gt; &quot;!r:domain&quot;, ...&gt; &quot;sender&quot; =&gt; &quot;@u:domain&quot;, ...&gt; &quot;signatures&quot; =&gt; %{}, ...&gt; &quot;unsigned&quot; =&gt; %{ ...&gt; &quot;age_ts&quot; =&gt; 1000000 ...&gt; } ...&gt; } ...&gt; ) { :ok, %{ &quot;content&quot; =&gt; %{}, &quot;event_id&quot; =&gt; &quot;$0:domain&quot;, &quot;origin&quot; =&gt; &quot;domain&quot;, &quot;origin_server_ts&quot; =&gt; 1000000, &quot;type&quot; =&gt; &quot;m.room.message&quot;, &quot;room_id&quot; =&gt; &quot;!r:domain&quot;, &quot;sender&quot; =&gt; &quot;@u:domain&quot;, &quot;signatures&quot; =&gt; %{} } } iex&gt; Polyjuice.Util.Event.redact( ...&gt; &quot;unknown room version&quot;, ...&gt; %{} ...&gt; ) :error"},{"ref":"Polyjuice.Util.JSON.html","title":"Polyjuice.Util.JSON","type":"module","doc":"JSON-related functions."},{"ref":"Polyjuice.Util.JSON.html#canonical_json/1","title":"Polyjuice.Util.JSON.canonical_json/1","type":"function","doc":"Encode a value as canonical JSON. See https://matrix.org/docs/spec/appendices#canonical-json for more information about canonical JSON. Examples: iex&gt; Polyjuice.Util.JSON.canonical_json(%{&quot;a&quot; =&gt; true, &quot;b&quot; =&gt; false, &quot;c&quot; =&gt; nil, &quot;d&quot; =&gt; 42, &quot;e&quot; =&gt; [], &quot;f&quot; =&gt; %{}}) {:ok, &quot;{\\&quot;a\\&quot;:true,\\&quot;b\\&quot;:false,\\&quot;c\\&quot;:null,\\&quot;d\\&quot;:42,\\&quot;e\\&quot;:[],\\&quot;f\\&quot;:{}}&quot;} iex&gt; Polyjuice.Util.JSON.canonical_json(%{&quot;本&quot;=&gt;2,&quot;日&quot;=&gt;1}) {:ok, &quot;{\\&quot;日\\&quot;:1,\\&quot;本\\&quot;:2}&quot;} iex&gt; Polyjuice.Util.JSON.canonical_json(&quot;a日\\t\\&quot;\\\\\\x01\\x0f\\x10\\x1f&quot;) {:ok, &quot;\\&quot;a日\\\\t\\\\\\&quot;\\\\\\\\\\\\u0001\\\\u000F\\\\u0010\\\\u001F\\&quot;&quot;} iex&gt; Polyjuice.Util.JSON.canonical_json([1,2,3,4]) {:ok, &quot;[1,2,3,4]&quot;} Unknown or invalid values will cause an error iex&gt; Polyjuice.Util.JSON.canonical_json([{}]) :error iex&gt; Polyjuice.Util.JSON.canonical_json([:foo]) :error iex&gt; Polyjuice.Util.JSON.canonical_json([0x40000000000000]) :error iex&gt; Polyjuice.Util.JSON.canonical_json([1.1]) :error"},{"ref":"Polyjuice.Util.JSON.html#sign/3","title":"Polyjuice.Util.JSON.sign/3","type":"function","doc":"Sign a JSON object. See https://matrix.org/docs/spec/appendices#signing-json for more information about signing JSON. Examples: iex&gt; Polyjuice.Util.JSON.sign( ...&gt; %{}, ...&gt; &quot;domain&quot;, ...&gt; Polyjuice.Util.Ed25519.SigningKey.from_base64(&quot;YJDBA9Xnr2sVqXD9Vj7XVUnmFZcZrlw8Md7kMW+3XA1&quot;, &quot;1&quot;) ...&gt; ) { :ok, %{ &quot;signatures&quot; =&gt; %{ &quot;domain&quot; =&gt; %{ &quot;ed25519:1&quot; =&gt; &quot;K8280/U9SSy9IVtjBuVeLr+HpOB4BQFWbg+UZaADMtTdGYI7Geitb76LTrr5QV/7Xg4ahLwYGYZzuHGZKM5ZAQ&quot; } } } } iex&gt; Polyjuice.Util.JSON.sign( ...&gt; %{&quot;one&quot; =&gt; 1, &quot;two&quot; =&gt; &quot;Two&quot;}, ...&gt; &quot;domain&quot;, ...&gt; Polyjuice.Util.Ed25519.SigningKey.from_base64(&quot;YJDBA9Xnr2sVqXD9Vj7XVUnmFZcZrlw8Md7kMW+3XA1&quot;, &quot;1&quot;) ...&gt; ) { :ok, %{ &quot;one&quot; =&gt; 1, &quot;signatures&quot; =&gt; %{ &quot;domain&quot; =&gt; %{ &quot;ed25519:1&quot; =&gt; &quot;KqmLSbO39/Bzb0QIYE82zqLwsA+PDzYIpIRA2sRQ4sL53+sN6/fpNSoqE7BP7vBZhG6kYdD13EIMJpvhJI+6Bw&quot; } }, &quot;two&quot; =&gt; &quot;Two&quot; } }"},{"ref":"Polyjuice.Util.JSON.html#verify/3","title":"Polyjuice.Util.JSON.verify/3","type":"function","doc":"Verify a signed JSON object. See https://matrix.org/docs/spec/appendices#signing-json for more information about signing JSON. Examples: iex&gt; Polyjuice.Util.JSON.verify( ...&gt; %{ ...&gt; &quot;signatures&quot; =&gt; %{ ...&gt; &quot;domain&quot; =&gt; %{ ...&gt; &quot;ed25519:1&quot; =&gt; &quot;K8280/U9SSy9IVtjBuVeLr+HpOB4BQFWbg+UZaADMtTdGYI7Geitb76LTrr5QV/7Xg4ahLwYGYZzuHGZKM5ZAQ&quot; ...&gt; } ...&gt; } ...&gt; }, ...&gt; &quot;domain&quot;, ...&gt; Polyjuice.Util.Ed25519.VerifyKey.from_base64(&quot;XGX0JRS2Af3be3knz2fBiRbApjm2Dh61gXDJA8kcJNI&quot;, &quot;1&quot;) ...&gt; ) true iex&gt; Polyjuice.Util.JSON.verify( ...&gt; %{ ...&gt; &quot;one&quot; =&gt; 1, ...&gt; &quot;signatures&quot; =&gt; %{ ...&gt; &quot;domain&quot; =&gt; %{ ...&gt; &quot;ed25519:1&quot; =&gt; &quot;KqmLSbO39/Bzb0QIYE82zqLwsA+PDzYIpIRA2sRQ4sL53+sN6/fpNSoqE7BP7vBZhG6kYdD13EIMJpvhJI+6Bw&quot; ...&gt; } ...&gt; }, ...&gt; &quot;two&quot; =&gt; &quot;Two&quot; ...&gt; }, ...&gt; &quot;domain&quot;, ...&gt; Polyjuice.Util.Ed25519.VerifyKey.from_base64(&quot;XGX0JRS2Af3be3knz2fBiRbApjm2Dh61gXDJA8kcJNI&quot;, &quot;1&quot;) ...&gt; ) true Missing signature: iex&gt; Polyjuice.Util.JSON.verify( ...&gt; %{ ...&gt; &quot;signatures&quot; =&gt; %{ ...&gt; &quot;domain&quot; =&gt; %{ ...&gt; &quot;ed25519:2&quot; =&gt; &quot;K8280/U9SSy9IVtjBuVeLr+HpOB4BQFWbg+UZaADMtTdGYI7Geitb76LTrr5QV/7Xg4ahLwYGYZzuHGZKM5ZAQ&quot; ...&gt; } ...&gt; } ...&gt; }, ...&gt; &quot;domain&quot;, ...&gt; Polyjuice.Util.Ed25519.VerifyKey.from_base64(&quot;XGX0JRS2Af3be3knz2fBiRbApjm2Dh61gXDJA8kcJNI&quot;, &quot;1&quot;) ...&gt; ) false Incorrect signature: iex&gt; Polyjuice.Util.JSON.verify( ...&gt; %{ ...&gt; &quot;signatures&quot; =&gt; %{ ...&gt; &quot;domain&quot; =&gt; %{ ...&gt; &quot;ed25519:1&quot; =&gt; &quot;00000000000000000000000000000000000000000000000000000000000000000000000000000000000000&quot; ...&gt; } ...&gt; } ...&gt; }, ...&gt; &quot;domain&quot;, ...&gt; Polyjuice.Util.Ed25519.VerifyKey.from_base64(&quot;XGX0JRS2Af3be3knz2fBiRbApjm2Dh61gXDJA8kcJNI&quot;, &quot;1&quot;) ...&gt; ) false"},{"ref":"Polyjuice.Util.SigningKey.html","title":"Polyjuice.Util.SigningKey","type":"protocol","doc":""},{"ref":"Polyjuice.Util.SigningKey.html#algorithm/1","title":"Polyjuice.Util.SigningKey.algorithm/1","type":"function","doc":""},{"ref":"Polyjuice.Util.SigningKey.html#id/1","title":"Polyjuice.Util.SigningKey.id/1","type":"function","doc":""},{"ref":"Polyjuice.Util.SigningKey.html#sign/2","title":"Polyjuice.Util.SigningKey.sign/2","type":"function","doc":""},{"ref":"Polyjuice.Util.SigningKey.html#version/1","title":"Polyjuice.Util.SigningKey.version/1","type":"function","doc":""},{"ref":"Polyjuice.Util.SigningKey.html#t:t/0","title":"Polyjuice.Util.SigningKey.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.VerifyKey.html","title":"Polyjuice.Util.VerifyKey","type":"protocol","doc":""},{"ref":"Polyjuice.Util.VerifyKey.html#algorithm/1","title":"Polyjuice.Util.VerifyKey.algorithm/1","type":"function","doc":""},{"ref":"Polyjuice.Util.VerifyKey.html#id/1","title":"Polyjuice.Util.VerifyKey.id/1","type":"function","doc":""},{"ref":"Polyjuice.Util.VerifyKey.html#verify/3","title":"Polyjuice.Util.VerifyKey.verify/3","type":"function","doc":""},{"ref":"Polyjuice.Util.VerifyKey.html#version/1","title":"Polyjuice.Util.VerifyKey.version/1","type":"function","doc":""},{"ref":"Polyjuice.Util.VerifyKey.html#t:t/0","title":"Polyjuice.Util.VerifyKey.t/0","type":"type","doc":""},{"ref":"readme.html","title":"Polyjuice Util","type":"extras","doc":"Polyjuice Util Utility functions for using the Matrix protocol. These are functions that are used by multiple components (e.g. clients, application services, identity services, homeservers)."},{"ref":"readme.html#installation","title":"Polyjuice Util - Installation","type":"extras","doc":"The package can be installed by adding polyjuice_util to your list of dependencies in mix.exs: def deps do [ {:polyjuice_util, &quot;~&gt; 0.1.0&quot;} ] end"}]